package moe.eos.heartparticlesresize;

import com.comphenix.protocol.PacketType;
import com.comphenix.protocol.ProtocolLibrary;
import com.comphenix.protocol.ProtocolManager;
import com.comphenix.protocol.events.ListenerPriority;
import com.comphenix.protocol.events.PacketAdapter;
import com.comphenix.protocol.events.PacketEvent;
import com.comphenix.protocol.wrappers.EnumWrappers;
import org.bukkit.plugin.java.JavaPlugin;

import java.lang.reflect.Field;
import java.util.List;

/**
 * @Author: EndOfStream
 * @Date: 2019/2/25 10:25
 */

public class HeartParticlesResize extends JavaPlugin {
    private static int scale = 1000;
    private static int baseValue = 3;
    private ProtocolManager protocolManager;

    @Override
    public void onEnable() {
        //保存默认配置
        saveDefaultConfig();
        //从配置中获取实际伤害和伤害显示粒子的比例
        scale = getConfig().getInt("scale", 1000);
        //从配置中获取造成伤害时候伤害显示粒子心数的下限
        baseValue = getConfig().getInt("baseValue", 3);
        //获取protocolManager
        protocolManager = ProtocolLibrary.getProtocolManager();
        //注册数据包监听器
        protocolManager.addPacketListener(
                //注册粒子数据包监听器
                new PacketAdapter(this, ListenerPriority.NORMAL,
                        PacketType.Play.Server.WORLD_PARTICLES) {
                    @Override
                    public void onPacketSending(PacketEvent event) {
                        if (event.getPacketType() ==
                                PacketType.Play.Server.WORLD_PARTICLES) {
                            List<EnumWrappers.Particle> particleList = event.getPacket().getParticles().getValues();
                            for (EnumWrappers.Particle particle : particleList) {
                                //粒子类别DAMAGE_INDICATOR
                                if (particle.equals(EnumWrappers.Particle.DAMAGE_INDICATOR)) {
                                    try {
                                        //获取粒子数据包中的储存DAMAGE_INDICATOR心数的field
                                        Field field = event.getPacket().getModifier().getField(8);
                                        //设置Field访问许可
                                        field.setAccessible(true);
                                        //获取造成的伤害值
                                        int originalDamage = field.getInt(event.getPacket().getParticles().getTarget()) * 2;
                                        if (originalDamage < scale) {
                                            field.setInt(event.getPacket().getParticles().getTarget(), baseValue);

                                        } else {
                                            field.setInt(event.getPacket().getParticles().getTarget(), baseValue + (int) Math.floor(originalDamage / scale));

                                        }
                                    } catch (IllegalAccessException e) {
                                        e.printStackTrace();
                                    }
                                }
                            }
                        }
                    }
                });
    }
}
